/**********************************************************************
  s߃T}\
  $Id: sum_cmd.c,v 1.3 2002/05/12 13:52:27 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

unsigned char tmpbuf[32] ;

int sum_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
  int i,j ;
  long long int sum ;

  if( tk_pt->pt[1]!=NULL ){
    if( strcmp(tk_pt->pt[1],"reset")==0 ){
      reset_exec_op_count() ;
      return(NORMAL_EXIT) ;
    }else{
      fprintf(simmsgfp,"Unknown subcommand (%s).\n",tk_pt->pt[1]) ;
      return(NORMAL_EXIT) ;
    }
  }
    
  sum=0 ;
  for( j=0 ; j<=1 ; j++ ){
    for( i=0 ; i<TBL_SIZE_bit00to05 ; i++ ){
      if( op_func_tbl[i].count!=0 ){
	if( i==0x13 || i==0x1f || i==0x3b || i==0x3f ) continue ;
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_func_tbl[i].name) ;
	  printll(simmsgfp,op_func_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_func_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_func_tbl[i].count ;
	}
      }
    }
    for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
      if( op_13_subfunc_tbl[i].count!=0 ){
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_13_subfunc_tbl[i].name) ;
	  printll(simmsgfp,op_13_subfunc_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_13_subfunc_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_13_subfunc_tbl[i].count ;
	}
      }
    }
    for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
      if( op_1f_subfunc_tbl[i].count!=0 ){
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_1f_subfunc_tbl[i].name) ;
	  printll(simmsgfp,op_1f_subfunc_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_1f_subfunc_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_1f_subfunc_tbl[i].count ;
	}
      }
    }
    for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
      if( op_3b_subfunc_tbl[i].count!=0 ){
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_3b_subfunc_tbl[i].name) ;
	  printll(simmsgfp,op_3b_subfunc_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_3b_subfunc_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_3b_subfunc_tbl[i].count ;
	}
      }
    }
    for( i=0 ; i<TBL_SIZE_bit21to30 ; i++ ){
      if( op_3f_subfunc0_tbl[i].count!=0 ){
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_3f_subfunc0_tbl[i].name) ;
	  printll(simmsgfp,op_3f_subfunc0_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_3f_subfunc0_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_3f_subfunc0_tbl[i].count ;
	}
      }
    }
    for( i=0 ; i<TBL_SIZE_bit27to30 ; i++ ){
      if( op_3f_subfunc1_tbl[i].count!=0 ){
	if( j==1 ){
	  fprintf(simmsgfp,"%-12s = ",op_3f_subfunc1_tbl[i].name) ;
	  printll(simmsgfp,op_3f_subfunc1_tbl[i].count,12) ;
	  sprintf(tmpbuf,"   %3.6f %%",(double)op_3f_subfunc1_tbl[i].count/sum*100.0) ;
	  fprintf(simmsgfp,"%14s",tmpbuf) ;
	  fprintf(simmsgfp,"\n") ;
	}else{
	  sum+=op_3f_subfunc1_tbl[i].count ;
	}
      }
    }
  }
  
  fprintf(simmsgfp,"Total_count  = ") ;
  printll(simmsgfp,sum,12) ;
  fprintf(simmsgfp,"\n") ;
  
  return(NORMAL_EXIT) ;
}

