/**********************************************************************
  Pass|Cg̍폜
  $Id: dpp_cmd.c,v 1.1 2002/04/29 03:39:13 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	dpp_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int i,j ;
int pid,id ;
int deleted ; 
  
  if( tk_pt->pt[1]==NULL ){
    fprintf(simmsgfp,"Invalid pass point ID.\n") ;
    return(NORMAL_EXIT) ;
  }else{
    id=exatoi(tk_pt->pt[1]) ;
  }
  
  if( tk_pt->pt[2]==NULL ){
    pid=proc_list.cur_id ;
  }else{
    if( tk_pt->pt[2][0]=='+' ){
      pid=proc_list.cur_id+1 ;
    }else{
      if( tk_pt->pt[2][0]=='-' ){
	pid=proc_list.cur_id-1 ;
      }else{
	pid=exatoi(tk_pt->pt[2]) ;
      }
    }
    if( pid>=MAX_PROCESS_ID || pid<0 ){
      fprintf(simmsgfp,"Invalid Process ID (Min=0,Max=%d specify=%d).\n",
	      (MAX_PROCESS_ID)-1,pid) ;
      return(NORMAL_EXIT) ;
    }
  }

  deleted=NO ;
  for( i=0 ; i<proc_list.proc[pid].pp_num ; i++ ){
    if( proc_list.proc[pid].pp[i].id == id ){
      for( j=i ; j<proc_list.proc[pid].pp_num ; j++ ){
	proc_list.proc[pid].pp[j].id = proc_list.proc[pid].pp[j+1].id ;

      }
      proc_list.proc[pid].pp_num-- ;
      deleted=YES ;
      break ;
    }
  }

  if( deleted==NO ){
    fprintf(simmsgfp,"ID=%d is not set.\n",id) ;
  }

  return(NORMAL_EXIT) ;

}
